(define (pk a)
  (console-log a)
  a)

;; snabbdom bindings

(define %patch (js-eval "patch"))

(define (patch old new)
  (js-call %patch old new)
  new)

(define %h (js-eval "h"))

(define (events->js-obj events)
  (alist->js-obj (map (lambda (name+proc)
			(cons (car name+proc) (js-closure (cdr name+proc))))
		      events)))

(define (h tag events . children)
  (let ((events (alist->js-obj `(("on" . ,(events->js-obj events))))))
    (js-call %h tag events (list->js-array children))))


;; alist helper

(define (alist-set alist key value)
  (map (lambda (pair)
	 (if (equal? (car pair) key)
	     (cons key value)
	     pair))
       alist))

(define (alist-ref alist key)
  (let loop ((alist alist))
    (cond
     ((null? alist) #f)
     ((equal? (caar alist) key) (cdar alist))
     (else (loop (cdr alist))))))
	     
;; app

;; FIXME: workaround the fact that ($ "#app") doesn't work
(define body (car (js-array->list ($ "body"))))
(define main (element-new '(div#main "getting started")))
(element-append-child! body main)


(define *state* `((counter0 . 0) (counter1 . 0) (counter2 . 0)))

(define (render)
  (set! main (patch main (view *state*))))

(define (action:increment counter-name)
  (lambda ()
    (set! *state* (alist-set *state* counter-name (+ (alist-ref *state* counter-name) 1)))
    (render)))
     
(define (view:counter name count)
  (h "div.counter" `(("click" . ,(action:increment name))) count))

(define (view state)
  (let ((counter0 (alist-ref *state* 'counter0))
	(counter1 (alist-ref *state* 'counter1))
	(counter2 (alist-ref *state* 'counter2)))
    (h "div#main" '()
       (view:counter 'counter0 counter0)
       (view:counter 'counter1 counter1)
       (view:counter 'counter2 counter2))))


(render)
